Subject: Re: [PATCH v5 05/11] mfd: macsmc: Add new __SMC_KEY macro

From: James Calligeros <[email-masked]>
Date: Fri, 28 Nov 2025 20:36:56 +1000

On Thursday, 20 November 2025 11:44:45 pm Australian Eastern Standard Time Lee 
Jones wrote:
> On Wed, 12 Nov 2025, James Calligeros wrote:
> > When using the _SMC_KEY macro in switch/case statements, GCC 15.2.1 errors
> > out with 'case label does not reduce to an integer constant'. Introduce
> > a new __SMC_KEY macro that can be used instead.
> > 
> > Signed-off-by: James Calligeros <[email-masked]>
> > ---
> > 
> >  include/linux/mfd/macsmc.h | 1 +
> >  1 file changed, 1 insertion(+)
> > 
> > diff --git a/include/linux/mfd/macsmc.h b/include/linux/mfd/macsmc.h
> > index 6b13f01a8592..f6f80c33b5cf 100644
> > --- a/include/linux/mfd/macsmc.h
> > +++ b/include/linux/mfd/macsmc.h
> > @@ -41,6 +41,7 @@ typedef u32 smc_key;
> > 
> >   */
> >  
> >  #define SMC_KEY(s) (smc_key)(_SMC_KEY(#s))
> >  #define _SMC_KEY(s) (((s)[0] << 24) | ((s)[1] << 16) | ((s)[2] << 8) |
> >  (s)[3])> 
> > +#define __SMC_KEY(a, b, c, d) (((u32)(a) << 24) | ((u32)(b) << 16) |
> > ((u32)(c) << 8) | ((u32)(d)))
> Are we expecting users/consumers to be able to tell the difference
> between SMC_KEY and __SMC_KEY (assuming that _SMC_KEY is just an
> internal)?

_SMC_KEY is used in the gpio driver, and I would have used it here too if not 
for GCC complaining about it. I wouldn't expect anyone to want to use 
__SMC_KEY outside of the specific use case this commit addresses given the 
suboptimal ergonomics.

> I have not tested this and it is just off the top of my head, but does
> this work:
> 
> #define _SMC_KEY(s) __SMC_KEY((s)[0], (s)[1], (s)[2], (s)[3])

This works fine on a smattering of M1 and M2 series machines. I can submit a 
v6 with this and the hwmon driver dropped if need be.

Regards,
James